<template>
  <q-card
    flat
    class="q-mt-lg rounded-borders-10"
    :class="{
      'q-pa-sm': screenWidth >= 768 && screenWidth <= 899,
      'q-pa-lg': screenWidth >= 900,
    }"
  >
    <q-card-section>
      <div class="row">
        <div class="col-3 q-my-auto">
          <label class="title-headline"> Skills </label>
        </div>

        <q-spacer />

        <div class="col" align="right">
          <q-btn
            unelevated
            no-caps
            text
            label="Add"
            icon="add"
            class="btn-md text-primary rounded-borders-10"
            @click="
              showAddSkill(skillStore.skills, referenceStore.skills),
                (showAddDialog = true)
            "
          />
        </div>
      </div>
    </q-card-section>

    <q-card-section>
      <div class="row q-mb-md">
        <div
          class="col-4"
          :class="{
            'col-12': $q.screen.lt.sm,
            'col-6': $q.screen.lt.md,
          }"
          v-for="(skill, k) in skillStore.skills"
          :key="k"
        >
          <ul>
            <div class="row">
              <div class="col">
                <li class="q-mt-sm">{{ skill.skill.name }}</li>
              </div>

              <div class="col q-mr-lg" align="right">
                <q-btn
                  unelevated
                  size="md"
                  icon="eva-trash-outline"
                  class="btn-delete text-grey-6"
                  @click="showDeleteSkill(skill.id), (showDeleteDialog = true)"
                />
              </div>
            </div>
          </ul>
        </div>
      </div>
    </q-card-section>
  </q-card>

  <!-- DIALOG: ADD SKILLS  -->
  <q-dialog v-model="showAddDialog" persistent @hide="showAddDialog === false">
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 900px; max-width: 90vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Add Skills</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section>
        <q-form @submit="addDetails(form)">
          <div class="row">
            <div class="col-12">
              <div class="q-py-xs">
                <q-select
                  v-model="form.skills"
                  :options="skillOptions"
                  use-input
                  hide-selected
                  fill-input
                  input-debounce="0"
                  option-label="name"
                  option-value="id"
                  dense
                  outlined
                  multiple
                  class="q-mt-sm"
                  @filter="filterSkillOptions"
                  :rules="[validations.requiredField]"
                />
              </div>
            </div>
          </div>

          <div class="row q-mt-lg">
            <div class="col-12 flex justify-content">
              <div v-for="(skill, k) in form.skills" :key="k">
                <q-chip
                  v-model="skill.name"
                  class="chip q-mt-sm"
                  color="white"
                  removable
                >
                  {{ skill.name }}
                </q-chip>
              </div>
            </div>
          </div>

          <div class="q-mt-xl flex justify-center">
            <q-btn
              class="btn-lg btn--shade-1 text-white"
              type="submit"
              label="SUBMIT"
              :loading="loading"
            />
          </div>
        </q-form>
      </q-card-section>
    </q-card>
  </q-dialog>

  <!-- DIALOG: DELETE SKILLS -->
  <q-dialog
    v-model="showDeleteDialog"
    persistent
    @hide="showDeleteDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-green-10">Delete Skill</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section class="q-pt-none">
        Are you sure you want to delete this entry?
      </q-card-section>

      <q-card-section>
        <div class="q-mt-xl flex justify-center">
          <q-btn
            unelevated
            class="btn-lg bg-negative text-white"
            label="DELETE"
            :loading="deleteLoading"
            @click="deleteDetails(form.id)"
          />
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>

<script>
import { defineComponent, ref, reactive, onMounted, onUnmounted } from "vue";
import { useSkill } from "../../store/skill";
// import { useReference } from "../../store/reference";
import { useReference } from "src/modules/auth/store/reference";
import { requiredField } from "src/hooks/validations";
import useJobseekerHook from "../../hooks/jobseekerHook";

export default defineComponent({
  setup() {
    const skillStore = useSkill();
    const { getMySkills } = skillStore;

    const referenceStore = useReference();
    const { getSkills } = referenceStore;

    const { loading, deleteLoading, doCreateSkill, doDeleteSkill } =
      useJobseekerHook();

    const screenWidth = ref(0);

    const showAddDialog = ref(false);
    const showDeleteDialog = ref(false);
    const skillOptions = ref([]);
    const form = reactive({
      id: null,
      skills: [],
    });

    const fetchUserDetails = () => {
      getMySkills();
    };

    const fetchSkillsList = () => {
      getSkills();
    };

    const resetForm = () => {
      form.skills = [];
    };

    const showAddSkill = (jobseekerSkills, referenceSkills) => {
      resetForm();

      skillOptions.value = referenceSkills.filter(
        (reference) =>
          !jobseekerSkills.some(
            (jobseeker) => reference.id === jobseeker.skill_id
          )
      );
    };

    const addDetails = async (form) => {
      await doCreateSkill(form);

      showAddDialog.value = false;
      fetchUserDetails();
    };

    const showDeleteSkill = (id) => {
      form.id = id;
      showDeleteDialog.value = true;
    };

    const deleteDetails = async (form) => {
      await doDeleteSkill(form);

      showDeleteDialog.value = false;
      fetchUserDetails();
    };

    onMounted(() => {
      window.addEventListener("resize", screenResize);
    });

    onUnmounted(() => {
      window.removeEventListener("resize", screenResize);
    });

    const screenResize = () => {
      screenWidth.value = window.innerWidth;
    };

    screenResize();

    (async () => {
      fetchUserDetails();
      fetchSkillsList();
    })();

    return {
      skillStore,
      referenceStore,
      form,
      loading,
      deleteLoading,
      showAddDialog,
      showDeleteDialog,
      skillOptions,
      validations: {
        requiredField,
      },
      showAddSkill,
      showDeleteSkill,
      addDetails,
      deleteDetails,
      filterSkillOptions(val, update, abort) {
        update(() => {
          const needle = val.toLowerCase();
          skillOptions.value = referenceStore.skills.filter(
            (v) => v.name.toLowerCase().indexOf(needle) > -1
          );
        });
      },
      screenResize,
      screenWidth,
    };
  },
});
</script>

<style lang="scss" scoped>
.btn-add {
  border-radius: 10px !important;
  padding: 10px !important;
}

.btn-delete {
  border-radius: 50px !important;
  padding: 5px !important;
}
</style>
